// ===============================================================
// =============  test MOTORI prima a SX poi a DX ================
// ===============================================================

#include <OrangutanAnalog.h>
#include <OrangutanMotors.h>
OrangutanAnalog analog;
OrangutanMotors motors;

const int Num = 4;  // Numero letture ADC per media

// ========================================================================
// ============================= PIN SENSORI ==============================
// ========================================================================
const int sharpL_pin = 0;   // SHARP SINISTRO
const int sharpR_pin = 1;   // SHARP DESTRO
const int battery_pin = 2;  // Batteria
const int cny70L_pin = 3;   // CNY70 SINISTRO
const int cny70R_pin = 5;   // CNY70 DESTRO

float sVL;
float sVR;

unsigned int val_sharpL = 0;
unsigned int val_sharpR = 0;
unsigned int arr_sharpL[10];
unsigned int arr_sharpR[10];
unsigned int val_cny70L = 0;
unsigned int val_cny70R = 0;
unsigned int val_battery = 0;
unsigned int i = 0;

unsigned long now, nextPrint;

void setup() {
  analog.setMode(MODE_10_BIT);    // 10-bit analog-to-digital conversions
  // test motori
  motors.setSpeeds(100, 0);  // set speeds of motors 1 (SX) and 2 (DX)  
  delay(1000);
  motors.setSpeeds(0, 100);  // set speeds of motors 1 (SX) and 2 (DX)  
  delay(1000);
  motors.setSpeeds(0, 0);  // set speeds of motors 1 (SX) and 2 (DX)  

  /*
  for (int j = 0; j < 10; j++) {
   arr_sharpL[j] = analog.read(sharpL_pin);
   arr_sharpR[j] = analog.read(sharpR_pin);
   }*/

  nextPrint = millis();

  Serial.begin(9600);

  //analogWrite(Pin_OUT_L,100);
  //analogWrite(Pin_OUT_R,100);
  //delay(1000);
  //analogWrite(Pin_OUT_L,0);
  //analogWrite(Pin_OUT_R,0);
}

// the loop routine runs over and over again forever:
void loop()
{ 
  // Lettura valori dai sensori

  val_battery = val_sharpL = val_sharpR = 0;
  val_cny70L = val_cny70R = 0;
  for (int j = 0; j < Num; j++) {
    val_battery += analog.read(battery_pin);
    delayMicroseconds(100);
    val_cny70L += analog.read(cny70L_pin);
    delayMicroseconds(100);
    val_cny70R += analog.read(cny70R_pin);
    delayMicroseconds(100);
    val_sharpL += analog.read(sharpL_pin);
    delayMicroseconds(100);
    val_sharpR += analog.read(sharpR_pin);
    delayMicroseconds(100);
  }
  val_battery /= Num;
  val_sharpL /= Num;
  val_sharpR /= Num;
  val_cny70L /= Num;
  val_cny70R /= Num;

  /*arr_sharpL[i] = analog.read(sharpL_pin);
   arr_sharpR[i] = analog.read(sharpR_pin);
   i++;
   if (!(i % 10)) {
   i = 0;
   }
   val_sharpL = 0;
   val_sharpR = 0;
   for (int j = 0; j < 10; j++) {
   val_sharpL += arr_sharpL[j];
   val_sharpR += arr_sharpR[j];
   }
   val_sharpL /= 10;
   val_sharpR /= 10;*/

  now = millis();
  if (now > nextPrint) {
    nextPrint = now + 500;

    Serial.print("SHARP Left: ");
    Serial.print(val_sharpL);

    Serial.print(" - SHARP Right: ");
    Serial.print(val_sharpR);

    Serial.print(" CNY70 Left: ");
    Serial.print(val_cny70L);

    Serial.print(" - CNY70 Right: ");
    Serial.print(val_cny70R);

    Serial.print(" Battery: ");
    Serial.println(val_battery);
  }
}



